#pragma once
#include "Entity.h"
#include "EntityStateGravity.h"
#include "EntityStateResist.h"
#include "EntityStateSplash.h"
#define CS_ENEMY_GIANTPIGNON2_CREATENAME L"CS_enemy_giantpignon2"
//敌人：巨大香菇（不会走出平台）
class CS_Enemy_GiantPignon2 :
    public Entity
{
public:
    CS_Enemy_GiantPignon2();
    void Init(std::weak_ptr<Entity> self) override;
    void Step() override;
    void SetState(int stateID, int lr) override;
    void Attack(std::weak_ptr<Entity> dst, int* outDamage, float* outAngle, bool* outTakedown, int* outElemType, float* outShockForce, float* outHeavy) override;
    bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
    EntityStateGravity stateGravity;
    EntityStateResist stateResist;
    EntityStateSplash stateSplash;
    void TurnBack();
};

std::shared_ptr<Entity> CreateCS_Enemy_GiantPignon2();